*** Elm113/f3.c	Sat Apr 18 14:52:52 1992
--- new/f3.c	Fri May 01 02:58:12 1992
***************
*** 10,15 ****
--- 10,20 ----
  #include <proto/dos.h>
  #include <proto/reqtools.h>
  #endif
+ #ifdef DICE
+ #include <clib/dos_protos.h>
+ #include <clib/exec_protos.h>
+ #include <clib/reqtools_protos.h>
+ #endif
  #include <libraries/reqtools.h>
  #include <time.h>
  
***************
*** 668,675 ****
  
  
  
! void status_msg(char *msg, long delay_time)
  {
    int hpos;
    if (intui_interface()) {
      hpos = (Win_Width-strlen(msg))/2;
--- 673,697 ----
  
  
  
! #ifdef DICE
! /* DICE has a compiler option '-gs' for supporting dynamic stack allocation.
!  * At each procedure call the code will check if less than 2000 bytes of
!  * free stack remains. If so, then more stack is allocted. If this allocation
!  * fails (because we are out of memory), stack_abort() is called.
!  *
!  * A requirement for dynamic stack allocation to work is that no procedure has
!  * more than (about) 2000 bytes of local variables.
!  */
! void stack_abort(void)
  {
+   clean_exit(20);
+ }
+ #endif
+ 
+ 
+ 
+ void status_msg(char *msg, long delay_time)
+ {
    int hpos;
    if (intui_interface()) {
      hpos = (Win_Width-strlen(msg))/2;
***************
*** 686,693 ****
  
  
  
! char *parse_arpa_from(char *str)
  {
    /** try to parse the 'From:' line given... It can be in one of
        two formats:
              From: Dave Taylor <hpcnou!dat>
--- 708,738 ----
  
  
  
! #ifdef DICE
! char *strrev(char *s)
  {
+     char *head, *tail;
+     char temp;
+ 
+     head = s;
+     tail = s + strlen(s);
+     tail--;
+ 
+     while (head < tail) {
+       temp = *head;
+       *head = *tail;
+       *tail = temp;
+       head++;
+       tail--;
+     }
+     return(s);
+ }
+ #endif
+ 
+ 
+ 
+ char *parse_arpa_from(char *str)
+ {
    /** try to parse the 'From:' line given... It can be in one of
        two formats:
              From: Dave Taylor <hpcnou!dat>
***************
*** 739,744 ****
--- 784,790 ----
      strrev(temp);
    }
  
+ #if 0
  /*
    /* We want a REAL name... else NULL... */
  
***************
*** 770,775 ****
--- 816,822 ----
      }
    }
  */
+ #endif
  
    temp = delete_wspaces_begin(temp);
    delete_wspaces_end(temp);
